/********************************************
   global procedures used in multiple files
*********************************************/


#include <malloc.h>
#include <stdio.h>
#include <ctype.h>

#include "common.h"
#include "globalProcs.h"


/********************************************
   static function declarations
*********************************************/

static void getTokenContents ( char [], char [], FILE * );

/********************************************
   function definitions
*********************************************/

char * xmalloc (unsigned size)
{
  register char *ptr = (char *) malloc (size);
  if (ptr != 0) return (ptr);
  {
     printf ("\nOut of memory.\n");
     exit(1);
  }
  /*NOTREACHED*/
  return 0;
}


extern BOOLEAN quoteString ( char str[] )
{
   int i;
   int len = strlen (str);
   
   for ( i=0; i < len; i++ )
      if ( isspace ( str[i] ) )
         return TRUE;

   return FALSE;
}

extern void getToken ( char token[MAX_TOKEN_SIZE], FILE *fdin )
{
   char str1[2] = "";
   char garbage[MAX_LINE_SIZE];
   BOOLEAN foundToken = FALSE;

   while ( ! feof(fdin) )
   {
      if ( foundToken )
         break;

      fscanf ( fdin ,"%c", str1 );
      while ( isspace( str1[0] ) )
      {
        if ( feof(fdin) )
           return;
        else
           fscanf ( fdin ,"%c", str1 );
      }

      if ( str1[0] == '#' )
      {         
            fgets ( garbage, MAX_LINE_SIZE, fdin );
      }
      else
      {  
         getTokenContents ( str1, token, fdin );
         foundToken = TRUE;
      }
   }
}

static void getTokenContents ( str1, token, fdin )
   char str1[2];
   char token[MAX_TOKEN_SIZE];
   FILE *fdin;
{
     if ( str1[0] == '"' )
     {
        int i = 0;
        
        while (1) 
        {
           if ( feof(fdin) )
              return;
           
           fscanf ( fdin, "%c", str1 );
           if ( str1[0] == '"' )
              break;
           token[i] = str1[0];
           i++;
        }
        
        token[i+1] = (char) NULL;
     }
     else 
     {
        int i = 0;
        
        do 
        {
           if ( feof(fdin) )
              return;
           
           token[i] = str1[0];
           i++;
           fscanf ( fdin, "%c", str1 );
        } while ( !isspace( str1[0] ) );
        
        token[i] = (char) NULL;
     }
}

